require 'spec_helper'

describe RubyYacht::DnsServer do
  describe "dsl" do
    let(:config) { RubyYacht::DnsServer::DSL.new.run(@builder).create_object }

    it "can add servers" do
      @builder = Proc.new do
        server '8.10.1.1'
        server '8.10.1.2'
      end

      expect(config.servers).to eq ['8.10.1.1', '8.10.1.2']
    end

    it "can add search domains" do
      @builder = Proc.new do
        search_domain 'apps.admin.test.com'
        search_domain 'web.admin.test.com'
      end
      
      expect(config.search_domains).to eq ['apps.admin.test.com', 'web.admin.test.com']
    end
  end
end