require "codeclimate-test-reporter"
CodeClimate::TestReporter.start
SimpleCov.start do
  coverage_dir 'doc/coverage'
  add_filter './spec'
end

require 'ruby_yacht'
require 'byebug'
require 'timecop'

Dir[File.join('.', 'spec', 'support', '**', '*.rb')].each { |f| require f }

unless File.exist?("~/.ssh/id_rsa")
  system "touch ~/.ssh/id_rsa"
end

RSpec.configure do |config|
  if ENV['PRESERVE_IMAGES'] != '1'
    config.after :suite do
      IntegrationHelpers.clear_docker_containers
      IntegrationHelpers.clear_docker_images
    end
  end
end